{% macro async_css(url) %}
    <script type="text/javascript">
        var ua=window.navigator.userAgent,fullVersion=String(parseFloat(window.navigator.appVersion)),majorVersion;if('Firefox'.in(ua)){fullVersion=ua.substring(ua.indexOf('Firefox')+8);majorVersion=parseInt(''+fullVersion,10);if(majorVersion>=42){loadCSS("{{ url }}");}else{var ls=document.createElement('link');ls.rel="stylesheet";ls.href="{{ url }}";document.getElementsByTagName('head')[0].appendChild(ls);}}else{loadCSS("{{ url }}");}
    </script>
    <noscript>
        <link rel="stylesheet" href="{{ url }}" type="text/css" />
    </noscript>
{% endmacro %}


{% macro js(url) %}
    <script src="{{ url }}" type="text/javascript" charset="utf-8" /></script>
{% endmacro %}


{% macro css(url) %}
    <link rel="stylesheet" href="{{ url }}" type="text/css" />
{% endmacro %}


{% macro alert(message, type='primary') %}
    <div class="alert alert-primary alert-dismissible" style="display:none" tabindex="-1" role="alert">
        {{ message }}
        <button class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <script>
        (function() {
            let $target = $(document.currentScript).prev('div.alert');
            $target.fadeIn('slow', function() {
                setTimeout(function() {
                    $target.fadeOut('slow');
                    setTimeout(function() {
                        $target.remove();
                    }, 600);
                }, 3000);
            });
        })();
    </script>
{% endmacro %}
